;==========================================================================
; VESA.ASM
; by Jim Gage for GASM 0.1
; I converted this over from a pascal program I wrote a few year ago that
; had support for a large number of video modes--most of them didn't work
; because I didn't have video boards to test them with.  Renamed to
; VESA.DRV is used by DRV.C.
;==========================================================================

.echo *********************************************************************
.echo             Make sure to rename VESA.COM to VESA.DRV
.echo *********************************************************************

;**************************************************************************
; Header
;**************************************************************************

dw  @@FinalOffset        ;Size of file + 2, size of driver + 4

.org  4                  ;Borland C uses 4 bytes of allocated memory

dw @initmode             ;point to initmode
dw @switchbanks          ;point to switchbanks

db 8,8,8,8,8,8,"VESA.DRV Written By Jim Gage",0dh,0ah,26

;**************************************************************************
; Code
;**************************************************************************

;--------------------------------------------------------------------------
; @initmode
; inits video to 640x480 256c
;--------------------------------------------------------------------------
@initmode:               ;set VESA video mode
       push ds           ;save ds
       push es           ;save es
       push di           ;save di

       push cs           ;ds<-cx
       pop  ds
       mov  ax,04f02h    ;VESA Set Mode
       mov  bx,0101h     ;640x480 256c
       int  010h         ;call Video interrupt
       cmp  al,04fh      ;al == 04fh
       jne  @exitfail    ;no? then failed
       mov  ax,04f01h    ;get granularity
       mov  cx,0101h     ;cx<-101
       push cs           ;es<-cs
       pop  es
       mov  di,@Buffer   ;load into 256 byte driver buffer
       int  010h         ;call Video interrupt
       mov  ax,es:[di+4] ;ax<-4th byte in buffer
       mov  [@gran],ax   ;@gran<-4th byte in buffer
       mov  ax,01        ;ax<-1, success
       jmp  @exit        ;jmp to exit
@exitfail:               ;init failed
       xor  ax,ax        ;ax<-0
@exit:
       pop  di           ;restore di
       pop  es           ;restore es
       pop  ds           ;restore ds
       retf              ;return

;--------------------------------------------------------------------------
; @switchbanks:
; Switches video banks
;--------------------------------------------------------------------------
@switchbanks:            ;switch banks
       push bp           ;setup stack frame
       mov  bp,sp
       push ds           ;save ds
       push cs           ;ds <- cs
       pop  ds
       mov  ax,[bp+6]    ;get bank from stack
       mov  bx,64        ;bx<-64
       mul  bx           ;dx:ax=bank*64
       mov  cx,[@gran]   ;cx<-@gran
       div  cx           ;ax=(bank*64)/windowgranularity
       mov  dx,ax        ;dx<-ax
       mov  ax,04f05h    ;ax<-4f05, VESA CPU VIDEO MEMORY CONTROL
       xor  bx,bx        ;bx <- 0
       int  010h         ;call video interrupt
       mov  ax,04f05h    ;ax<-4f05, VESA CPU VIDEO MEMORY CONTROL
       mov  bx,1         ;bx <- 1
       int  010h         ;call video interrupt
       pop  ds           ;restore ds
       pop  bp           ;restore bp
       retf              ;return

;**************************************************************************
; Data
;**************************************************************************

@gran:   dw 0
@Buffer: db 0100h dup(0)

; done

